# AutoCertificate

Auto certificates create new certificates based on a certificate provider.

This tag groups all operations for autocertificate.

## Retrieve all AutoCertificate

> This endpoint enables retrieving all AutoCertificate using\
> pagination and optional filters.<br>

```json
{"openapi":"3.0.3","info":{"title":"Certificate Manager Service API","version":"2.0"},"tags":[{"name":"AutoCertificate","description":"Auto certificates create new certificates based\non a certificate provider.\n\nThis tag groups all operations for autocertificate.\n"}],"servers":[{"url":"https://certificate-manager.de-fra.ionos.com","description":"Frankfurt"}],"security":[{"tokenAuth":[]}],"components":{"securitySchemes":{"tokenAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT","description":"The token can be generated using the \n[Authentication API](https://api.ionos.com/docs/authentication/v1/#tag/tokens/operation/tokensGenerate).\n"}},"parameters":{"paginationOffset":{"name":"offset","in":"query","description":"The first element (of the total list of elements) to include in the response. Use together with limit for pagination.","required":false,"schema":{"type":"integer","format":"int32","default":0,"minimum":0}},"paginationLimit":{"name":"limit","in":"query","description":"The maximum number of elements to return. Use together with offset for pagination.","required":false,"schema":{"type":"integer","format":"int32","default":100,"minimum":1,"maximum":1000}},"commonNameFilter":{"name":"filter.commonName","in":"query","description":"Filter by the common name (DNS).\n","required":false,"schema":{"type":"string"}}},"schemas":{"AutoCertificateReadList":{"allOf":[{"type":"object","required":["id","type","href"],"properties":{"id":{"description":"ID of the list of AutoCertificate resources.","type":"string","format":"uuid"},"type":{"description":"The type of the resource.","type":"string","enum":["collection"]},"href":{"description":"The URL of the list of AutoCertificate resources.","type":"string"},"items":{"description":"The list of AutoCertificate resources.","type":"array","items":{"$ref":"#/components/schemas/AutoCertificateRead"}}}},{"$ref":"#/components/schemas/Pagination"}]},"AutoCertificateRead":{"type":"object","required":["id","type","href","metadata","properties"],"properties":{"id":{"type":"string","description":"The ID (UUID) of the AutoCertificate.","format":"uuid"},"type":{"description":"The type of the resource.","type":"string","enum":["autocertificate"]},"href":{"description":"The URL of the AutoCertificate.","type":"string"},"metadata":{"$ref":"#/components/schemas/MetadataWithAutoCertificateInformation"},"properties":{"$ref":"#/components/schemas/AutoCertificate"}}},"MetadataWithAutoCertificateInformation":{"allOf":[{"$ref":"#/components/schemas/MetadataWithStatus"},{"type":"object","properties":{"lastIssuedCertificate":{"type":"string","format":"uuid","description":"The ID of the last certificate that was issued."}}}]},"MetadataWithStatus":{"readOnly":true,"allOf":[{"$ref":"#/components/schemas/Metadata"},{"type":"object","required":["state","message"],"properties":{"state":{"type":"string","description":"The resource state.","enum":["PROVISIONING","AVAILABLE","FAILED"]},"message":{"type":"string","description":"A human readable message describing the current state.\nIn case of an error, the message will contain a detailed error message.\n"}}}]},"Metadata":{"type":"object","description":"Metadata of the resource.","properties":{"createdDate":{"type":"string","format":"date-time","description":"The ISO 8601 creation timestamp.","readOnly":true},"createdBy":{"type":"string","description":"Unique name of the identity that created the resource.","readOnly":true},"createdByUserId":{"type":"string","description":"Unique id of the identity that created the resource.","readOnly":true},"lastModifiedDate":{"type":"string","format":"date-time","description":"The ISO 8601 modified timestamp.","readOnly":true},"lastModifiedBy":{"type":"string","description":"Unique name of the identity that last modified the resource.","readOnly":true},"lastModifiedByUserId":{"type":"string","description":"Unique id of the identity that last modified the resource.","readOnly":true},"resourceURN":{"type":"string","description":"Unique name of the resource.","readOnly":true}}},"AutoCertificate":{"description":"Auto certificates create new certificates based\non a certificate provider.\n","type":"object","required":["provider","commonName","keyAlgorithm","name"],"properties":{"provider":{"type":"string","format":"uuid","description":"The certificate provider used to issue the certificates."},"commonName":{"type":"string","description":"The common name (DNS) of the certificate to issue.\nThe common name needs to be part of a zone in IONOS Cloud DNS.\n"},"keyAlgorithm":{"type":"string","description":"The key algorithm used to generate the certificate.","enum":["rsa2048","rsa3072","rsa4096"]},"name":{"type":"string","description":"A certificate name used for management purposes."},"subjectAlternativeNames":{"type":"array","items":{"type":"string"},"description":"Optional additional names to be added to the issued certificate.\nThe additional names needs to be part of a zone in IONOS Cloud DNS.\n"}}},"Pagination":{"required":["offset","limit","_links"],"description":"Pagination information. The offset and limit parameters are used to\nnavigate the list of elements. The _links object contains URLs to\nnavigate the different pages.\n","type":"object","properties":{"offset":{"$ref":"#/components/schemas/Offset"},"limit":{"$ref":"#/components/schemas/Limit"},"_links":{"$ref":"#/components/schemas/Links"}}},"Offset":{"description":"The offset specified in the request (if none was specified, the default\noffset is 0).\n","type":"integer","minimum":0,"readOnly":true},"Limit":{"description":"The limit specified in the request (if none was specified, use the\nendpoint's default pagination limit).\n","type":"integer","minimum":0,"readOnly":true},"Links":{"description":"URLs to navigate the different pages. As of now we always only return a\nsingle page.\n","type":"object","properties":{"prev":{"description":"URL (with offset and limit parameters) of the previous page; only\npresent if offset is greater than 0.\n","type":"string","format":"uri","readOnly":true},"self":{"description":"URL (with offset and limit parameters) of the current page.\n","type":"string","format":"uri","readOnly":true},"next":{"description":"URL (with offset and limit parameters) of the next page; only\npresent if offset + limit is less than the total number of elements.\n","type":"string","format":"uri","readOnly":true}}},"Error":{"description":"The Error object is used to represent an error response from the API.\n","type":"object","properties":{"httpStatus":{"type":"integer","description":"The HTTP status code of the operation."},"messages":{"type":"array","description":"A list of error messages.\n","items":{"type":"object","properties":{"errorCode":{"type":"string","description":"Application internal error code\n"},"message":{"type":"string","description":"A human readable explanation specific to this occurrence of the\nproblem.\n"}}}}}}},"responses":{"BadRequest":{"description":"### Bad Request\nThe request send to the API was malformed.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"Unauthorized":{"description":"### Unauthorized\nThe request is missing authorization information or the authorization information provided are expired.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotAllowed":{"description":"### Not Allowed\nThe user issuing the request does not have the needed permissions.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"TooManyRequests":{"description":"### Too Many Requests\nThe user has sent too many requests in a given amount of time.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"InternalError":{"description":"### Internal Server Error\nAn internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"ServiceUnavailable":{"description":"### Service Unavailable\nThe server is currently unable to handle the request due to a temporary overloading or maintenance of the server.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnexpectedError":{"description":"### Unexpected Internal Server Error\nAn unexpected internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}},"paths":{"/auto-certificates":{"get":{"operationId":"autoCertificatesGet","summary":"Retrieve all AutoCertificate","description":"This endpoint enables retrieving all AutoCertificate using\npagination and optional filters.\n","parameters":[{"$ref":"#/components/parameters/paginationOffset"},{"$ref":"#/components/parameters/paginationLimit"},{"$ref":"#/components/parameters/commonNameFilter"}],"tags":["AutoCertificate"],"responses":{"200":{"description":"Returned all requested AutoCertificate successfully.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/AutoCertificateReadList"}}}},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/NotAllowed"},"429":{"$ref":"#/components/responses/TooManyRequests"},"500":{"$ref":"#/components/responses/InternalError"},"503":{"$ref":"#/components/responses/ServiceUnavailable"},"default":{"$ref":"#/components/responses/UnexpectedError"}}}}}}
```

## Create AutoCertificate

> Creates a new AutoCertificate.\
> \
> The full AutoCertificate needs to be provided to create the object.\
> Optional data will be filled with defaults or left empty.<br>

```json
{"openapi":"3.0.3","info":{"title":"Certificate Manager Service API","version":"2.0"},"tags":[{"name":"AutoCertificate","description":"Auto certificates create new certificates based\non a certificate provider.\n\nThis tag groups all operations for autocertificate.\n"}],"servers":[{"url":"https://certificate-manager.de-fra.ionos.com","description":"Frankfurt"}],"security":[{"tokenAuth":[]}],"components":{"securitySchemes":{"tokenAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT","description":"The token can be generated using the \n[Authentication API](https://api.ionos.com/docs/authentication/v1/#tag/tokens/operation/tokensGenerate).\n"}},"schemas":{"AutoCertificateCreate":{"type":"object","required":["properties"],"properties":{"metadata":{"description":"Metadata","additionalProperties":true},"properties":{"$ref":"#/components/schemas/AutoCertificate"}}},"AutoCertificate":{"description":"Auto certificates create new certificates based\non a certificate provider.\n","type":"object","required":["provider","commonName","keyAlgorithm","name"],"properties":{"provider":{"type":"string","format":"uuid","description":"The certificate provider used to issue the certificates."},"commonName":{"type":"string","description":"The common name (DNS) of the certificate to issue.\nThe common name needs to be part of a zone in IONOS Cloud DNS.\n"},"keyAlgorithm":{"type":"string","description":"The key algorithm used to generate the certificate.","enum":["rsa2048","rsa3072","rsa4096"]},"name":{"type":"string","description":"A certificate name used for management purposes."},"subjectAlternativeNames":{"type":"array","items":{"type":"string"},"description":"Optional additional names to be added to the issued certificate.\nThe additional names needs to be part of a zone in IONOS Cloud DNS.\n"}}},"AutoCertificateRead":{"type":"object","required":["id","type","href","metadata","properties"],"properties":{"id":{"type":"string","description":"The ID (UUID) of the AutoCertificate.","format":"uuid"},"type":{"description":"The type of the resource.","type":"string","enum":["autocertificate"]},"href":{"description":"The URL of the AutoCertificate.","type":"string"},"metadata":{"$ref":"#/components/schemas/MetadataWithAutoCertificateInformation"},"properties":{"$ref":"#/components/schemas/AutoCertificate"}}},"MetadataWithAutoCertificateInformation":{"allOf":[{"$ref":"#/components/schemas/MetadataWithStatus"},{"type":"object","properties":{"lastIssuedCertificate":{"type":"string","format":"uuid","description":"The ID of the last certificate that was issued."}}}]},"MetadataWithStatus":{"readOnly":true,"allOf":[{"$ref":"#/components/schemas/Metadata"},{"type":"object","required":["state","message"],"properties":{"state":{"type":"string","description":"The resource state.","enum":["PROVISIONING","AVAILABLE","FAILED"]},"message":{"type":"string","description":"A human readable message describing the current state.\nIn case of an error, the message will contain a detailed error message.\n"}}}]},"Metadata":{"type":"object","description":"Metadata of the resource.","properties":{"createdDate":{"type":"string","format":"date-time","description":"The ISO 8601 creation timestamp.","readOnly":true},"createdBy":{"type":"string","description":"Unique name of the identity that created the resource.","readOnly":true},"createdByUserId":{"type":"string","description":"Unique id of the identity that created the resource.","readOnly":true},"lastModifiedDate":{"type":"string","format":"date-time","description":"The ISO 8601 modified timestamp.","readOnly":true},"lastModifiedBy":{"type":"string","description":"Unique name of the identity that last modified the resource.","readOnly":true},"lastModifiedByUserId":{"type":"string","description":"Unique id of the identity that last modified the resource.","readOnly":true},"resourceURN":{"type":"string","description":"Unique name of the resource.","readOnly":true}}},"Error":{"description":"The Error object is used to represent an error response from the API.\n","type":"object","properties":{"httpStatus":{"type":"integer","description":"The HTTP status code of the operation."},"messages":{"type":"array","description":"A list of error messages.\n","items":{"type":"object","properties":{"errorCode":{"type":"string","description":"Application internal error code\n"},"message":{"type":"string","description":"A human readable explanation specific to this occurrence of the\nproblem.\n"}}}}}}},"responses":{"BadRequest":{"description":"### Bad Request\nThe request send to the API was malformed.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"Unauthorized":{"description":"### Unauthorized\nThe request is missing authorization information or the authorization information provided are expired.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotAllowed":{"description":"### Not Allowed\nThe user issuing the request does not have the needed permissions.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnsupportedMediaType":{"description":"### Unsupported Media Type\nThe request has an unsupported media type.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnprocessableEntity":{"description":"### Unprocessable Entity\nThe request was well-formed but was unable to be followed due to semantic errors.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"TooManyRequests":{"description":"### Too Many Requests\nThe user has sent too many requests in a given amount of time.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"InternalError":{"description":"### Internal Server Error\nAn internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"ServiceUnavailable":{"description":"### Service Unavailable\nThe server is currently unable to handle the request due to a temporary overloading or maintenance of the server.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnexpectedError":{"description":"### Unexpected Internal Server Error\nAn unexpected internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}},"paths":{"/auto-certificates":{"post":{"operationId":"autoCertificatesPost","summary":"Create AutoCertificate","tags":["AutoCertificate"],"description":"Creates a new AutoCertificate.\n\nThe full AutoCertificate needs to be provided to create the object.\nOptional data will be filled with defaults or left empty.\n","requestBody":{"description":"AutoCertificate to create.","required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/AutoCertificateCreate"}}}},"responses":{"201":{"description":"AutoCertificate successfully created.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/AutoCertificateRead"}}}},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/NotAllowed"},"415":{"$ref":"#/components/responses/UnsupportedMediaType"},"422":{"$ref":"#/components/responses/UnprocessableEntity"},"429":{"$ref":"#/components/responses/TooManyRequests"},"500":{"$ref":"#/components/responses/InternalError"},"503":{"$ref":"#/components/responses/ServiceUnavailable"},"default":{"$ref":"#/components/responses/UnexpectedError"}}}}}}
```

## Retrieve AutoCertificate

> Returns the AutoCertificate by ID.

```json
{"openapi":"3.0.3","info":{"title":"Certificate Manager Service API","version":"2.0"},"tags":[{"name":"AutoCertificate","description":"Auto certificates create new certificates based\non a certificate provider.\n\nThis tag groups all operations for autocertificate.\n"}],"servers":[{"url":"https://certificate-manager.de-fra.ionos.com","description":"Frankfurt"}],"security":[{"tokenAuth":[]}],"components":{"securitySchemes":{"tokenAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT","description":"The token can be generated using the \n[Authentication API](https://api.ionos.com/docs/authentication/v1/#tag/tokens/operation/tokensGenerate).\n"}},"schemas":{"AutoCertificateRead":{"type":"object","required":["id","type","href","metadata","properties"],"properties":{"id":{"type":"string","description":"The ID (UUID) of the AutoCertificate.","format":"uuid"},"type":{"description":"The type of the resource.","type":"string","enum":["autocertificate"]},"href":{"description":"The URL of the AutoCertificate.","type":"string"},"metadata":{"$ref":"#/components/schemas/MetadataWithAutoCertificateInformation"},"properties":{"$ref":"#/components/schemas/AutoCertificate"}}},"MetadataWithAutoCertificateInformation":{"allOf":[{"$ref":"#/components/schemas/MetadataWithStatus"},{"type":"object","properties":{"lastIssuedCertificate":{"type":"string","format":"uuid","description":"The ID of the last certificate that was issued."}}}]},"MetadataWithStatus":{"readOnly":true,"allOf":[{"$ref":"#/components/schemas/Metadata"},{"type":"object","required":["state","message"],"properties":{"state":{"type":"string","description":"The resource state.","enum":["PROVISIONING","AVAILABLE","FAILED"]},"message":{"type":"string","description":"A human readable message describing the current state.\nIn case of an error, the message will contain a detailed error message.\n"}}}]},"Metadata":{"type":"object","description":"Metadata of the resource.","properties":{"createdDate":{"type":"string","format":"date-time","description":"The ISO 8601 creation timestamp.","readOnly":true},"createdBy":{"type":"string","description":"Unique name of the identity that created the resource.","readOnly":true},"createdByUserId":{"type":"string","description":"Unique id of the identity that created the resource.","readOnly":true},"lastModifiedDate":{"type":"string","format":"date-time","description":"The ISO 8601 modified timestamp.","readOnly":true},"lastModifiedBy":{"type":"string","description":"Unique name of the identity that last modified the resource.","readOnly":true},"lastModifiedByUserId":{"type":"string","description":"Unique id of the identity that last modified the resource.","readOnly":true},"resourceURN":{"type":"string","description":"Unique name of the resource.","readOnly":true}}},"AutoCertificate":{"description":"Auto certificates create new certificates based\non a certificate provider.\n","type":"object","required":["provider","commonName","keyAlgorithm","name"],"properties":{"provider":{"type":"string","format":"uuid","description":"The certificate provider used to issue the certificates."},"commonName":{"type":"string","description":"The common name (DNS) of the certificate to issue.\nThe common name needs to be part of a zone in IONOS Cloud DNS.\n"},"keyAlgorithm":{"type":"string","description":"The key algorithm used to generate the certificate.","enum":["rsa2048","rsa3072","rsa4096"]},"name":{"type":"string","description":"A certificate name used for management purposes."},"subjectAlternativeNames":{"type":"array","items":{"type":"string"},"description":"Optional additional names to be added to the issued certificate.\nThe additional names needs to be part of a zone in IONOS Cloud DNS.\n"}}},"Error":{"description":"The Error object is used to represent an error response from the API.\n","type":"object","properties":{"httpStatus":{"type":"integer","description":"The HTTP status code of the operation."},"messages":{"type":"array","description":"A list of error messages.\n","items":{"type":"object","properties":{"errorCode":{"type":"string","description":"Application internal error code\n"},"message":{"type":"string","description":"A human readable explanation specific to this occurrence of the\nproblem.\n"}}}}}}},"responses":{"BadRequest":{"description":"### Bad Request\nThe request send to the API was malformed.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"Unauthorized":{"description":"### Unauthorized\nThe request is missing authorization information or the authorization information provided are expired.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotAllowed":{"description":"### Not Allowed\nThe user issuing the request does not have the needed permissions.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotFound":{"description":"### Not Found\nThe resource that was requested could not be found.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"TooManyRequests":{"description":"### Too Many Requests\nThe user has sent too many requests in a given amount of time.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"InternalError":{"description":"### Internal Server Error\nAn internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"ServiceUnavailable":{"description":"### Service Unavailable\nThe server is currently unable to handle the request due to a temporary overloading or maintenance of the server.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnexpectedError":{"description":"### Unexpected Internal Server Error\nAn unexpected internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}},"paths":{"/auto-certificates/{autoCertificateId}":{"get":{"operationId":"autoCertificatesFindById","summary":"Retrieve AutoCertificate","tags":["AutoCertificate"],"description":"Returns the AutoCertificate by ID.","parameters":[{"name":"autoCertificateId","in":"path","schema":{"type":"string","format":"uuid"},"required":true,"description":"The ID (UUID) of the AutoCertificate."}],"responses":{"200":{"description":"Getting AutoCertificate was successful.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/AutoCertificateRead"}}}},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/NotAllowed"},"404":{"$ref":"#/components/responses/NotFound"},"429":{"$ref":"#/components/responses/TooManyRequests"},"500":{"$ref":"#/components/responses/InternalError"},"503":{"$ref":"#/components/responses/ServiceUnavailable"},"default":{"$ref":"#/components/responses/UnexpectedError"}}}}}}
```

## Delete AutoCertificate

> Deletes the specified AutoCertificate.

```json
{"openapi":"3.0.3","info":{"title":"Certificate Manager Service API","version":"2.0"},"tags":[{"name":"AutoCertificate","description":"Auto certificates create new certificates based\non a certificate provider.\n\nThis tag groups all operations for autocertificate.\n"}],"servers":[{"url":"https://certificate-manager.de-fra.ionos.com","description":"Frankfurt"}],"security":[{"tokenAuth":[]}],"components":{"securitySchemes":{"tokenAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT","description":"The token can be generated using the \n[Authentication API](https://api.ionos.com/docs/authentication/v1/#tag/tokens/operation/tokensGenerate).\n"}},"responses":{"BadRequest":{"description":"### Bad Request\nThe request send to the API was malformed.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"Unauthorized":{"description":"### Unauthorized\nThe request is missing authorization information or the authorization information provided are expired.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotAllowed":{"description":"### Not Allowed\nThe user issuing the request does not have the needed permissions.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotFound":{"description":"### Not Found\nThe resource that was requested could not be found.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"TooManyRequests":{"description":"### Too Many Requests\nThe user has sent too many requests in a given amount of time.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"InternalError":{"description":"### Internal Server Error\nAn internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"ServiceUnavailable":{"description":"### Service Unavailable\nThe server is currently unable to handle the request due to a temporary overloading or maintenance of the server.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnexpectedError":{"description":"### Unexpected Internal Server Error\nAn unexpected internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}},"schemas":{"Error":{"description":"The Error object is used to represent an error response from the API.\n","type":"object","properties":{"httpStatus":{"type":"integer","description":"The HTTP status code of the operation."},"messages":{"type":"array","description":"A list of error messages.\n","items":{"type":"object","properties":{"errorCode":{"type":"string","description":"Application internal error code\n"},"message":{"type":"string","description":"A human readable explanation specific to this occurrence of the\nproblem.\n"}}}}}}}},"paths":{"/auto-certificates/{autoCertificateId}":{"delete":{"operationId":"autoCertificatesDelete","summary":"Delete AutoCertificate","tags":["AutoCertificate"],"description":"Deletes the specified AutoCertificate.","parameters":[{"name":"autoCertificateId","in":"path","schema":{"type":"string","format":"uuid"},"required":true,"description":"The ID (UUID) of the AutoCertificate."}],"responses":{"202":{"description":"Deleting AutoCertificate was successful."},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/NotAllowed"},"404":{"$ref":"#/components/responses/NotFound"},"429":{"$ref":"#/components/responses/TooManyRequests"},"500":{"$ref":"#/components/responses/InternalError"},"503":{"$ref":"#/components/responses/ServiceUnavailable"},"default":{"$ref":"#/components/responses/UnexpectedError"}}}}}}
```

## Updates AutoCertificate

> Changes AutoCertificate with the provided ID.\
> Values provides will replace the existing data.<br>

```json
{"openapi":"3.0.3","info":{"title":"Certificate Manager Service API","version":"2.0"},"tags":[{"name":"AutoCertificate","description":"Auto certificates create new certificates based\non a certificate provider.\n\nThis tag groups all operations for autocertificate.\n"}],"servers":[{"url":"https://certificate-manager.de-fra.ionos.com","description":"Frankfurt"}],"security":[{"tokenAuth":[]}],"components":{"securitySchemes":{"tokenAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT","description":"The token can be generated using the \n[Authentication API](https://api.ionos.com/docs/authentication/v1/#tag/tokens/operation/tokensGenerate).\n"}},"schemas":{"AutoCertificatePatch":{"type":"object","required":["properties"],"properties":{"metadata":{"description":"Metadata","additionalProperties":true},"properties":{"$ref":"#/components/schemas/PatchName"}}},"PatchName":{"required":["name"],"properties":{"name":{"type":"string","description":"The new name."}}},"AutoCertificateRead":{"type":"object","required":["id","type","href","metadata","properties"],"properties":{"id":{"type":"string","description":"The ID (UUID) of the AutoCertificate.","format":"uuid"},"type":{"description":"The type of the resource.","type":"string","enum":["autocertificate"]},"href":{"description":"The URL of the AutoCertificate.","type":"string"},"metadata":{"$ref":"#/components/schemas/MetadataWithAutoCertificateInformation"},"properties":{"$ref":"#/components/schemas/AutoCertificate"}}},"MetadataWithAutoCertificateInformation":{"allOf":[{"$ref":"#/components/schemas/MetadataWithStatus"},{"type":"object","properties":{"lastIssuedCertificate":{"type":"string","format":"uuid","description":"The ID of the last certificate that was issued."}}}]},"MetadataWithStatus":{"readOnly":true,"allOf":[{"$ref":"#/components/schemas/Metadata"},{"type":"object","required":["state","message"],"properties":{"state":{"type":"string","description":"The resource state.","enum":["PROVISIONING","AVAILABLE","FAILED"]},"message":{"type":"string","description":"A human readable message describing the current state.\nIn case of an error, the message will contain a detailed error message.\n"}}}]},"Metadata":{"type":"object","description":"Metadata of the resource.","properties":{"createdDate":{"type":"string","format":"date-time","description":"The ISO 8601 creation timestamp.","readOnly":true},"createdBy":{"type":"string","description":"Unique name of the identity that created the resource.","readOnly":true},"createdByUserId":{"type":"string","description":"Unique id of the identity that created the resource.","readOnly":true},"lastModifiedDate":{"type":"string","format":"date-time","description":"The ISO 8601 modified timestamp.","readOnly":true},"lastModifiedBy":{"type":"string","description":"Unique name of the identity that last modified the resource.","readOnly":true},"lastModifiedByUserId":{"type":"string","description":"Unique id of the identity that last modified the resource.","readOnly":true},"resourceURN":{"type":"string","description":"Unique name of the resource.","readOnly":true}}},"AutoCertificate":{"description":"Auto certificates create new certificates based\non a certificate provider.\n","type":"object","required":["provider","commonName","keyAlgorithm","name"],"properties":{"provider":{"type":"string","format":"uuid","description":"The certificate provider used to issue the certificates."},"commonName":{"type":"string","description":"The common name (DNS) of the certificate to issue.\nThe common name needs to be part of a zone in IONOS Cloud DNS.\n"},"keyAlgorithm":{"type":"string","description":"The key algorithm used to generate the certificate.","enum":["rsa2048","rsa3072","rsa4096"]},"name":{"type":"string","description":"A certificate name used for management purposes."},"subjectAlternativeNames":{"type":"array","items":{"type":"string"},"description":"Optional additional names to be added to the issued certificate.\nThe additional names needs to be part of a zone in IONOS Cloud DNS.\n"}}},"Error":{"description":"The Error object is used to represent an error response from the API.\n","type":"object","properties":{"httpStatus":{"type":"integer","description":"The HTTP status code of the operation."},"messages":{"type":"array","description":"A list of error messages.\n","items":{"type":"object","properties":{"errorCode":{"type":"string","description":"Application internal error code\n"},"message":{"type":"string","description":"A human readable explanation specific to this occurrence of the\nproblem.\n"}}}}}}},"responses":{"BadRequest":{"description":"### Bad Request\nThe request send to the API was malformed.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"Unauthorized":{"description":"### Unauthorized\nThe request is missing authorization information or the authorization information provided are expired.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotAllowed":{"description":"### Not Allowed\nThe user issuing the request does not have the needed permissions.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotFound":{"description":"### Not Found\nThe resource that was requested could not be found.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"Conflict":{"description":"### Conflict\nThe UUID is already taken by another party, follow the guides to generate UUIDs uniquely.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnsupportedMediaType":{"description":"### Unsupported Media Type\nThe request has an unsupported media type.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnprocessableEntity":{"description":"### Unprocessable Entity\nThe request was well-formed but was unable to be followed due to semantic errors.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"TooManyRequests":{"description":"### Too Many Requests\nThe user has sent too many requests in a given amount of time.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"InternalError":{"description":"### Internal Server Error\nAn internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"ServiceUnavailable":{"description":"### Service Unavailable\nThe server is currently unable to handle the request due to a temporary overloading or maintenance of the server.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnexpectedError":{"description":"### Unexpected Internal Server Error\nAn unexpected internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}},"paths":{"/auto-certificates/{autoCertificateId}":{"patch":{"operationId":"autoCertificatesPatch","summary":"Updates AutoCertificate","tags":["AutoCertificate"],"description":"Changes AutoCertificate with the provided ID.\nValues provides will replace the existing data.\n","parameters":[{"name":"autoCertificateId","in":"path","schema":{"type":"string","format":"uuid"},"required":true,"description":"The ID (UUID) of the AutoCertificate."}],"requestBody":{"description":"patch AutoCertificate","required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/AutoCertificatePatch"}}}},"responses":{"200":{"description":"AutoCertificate successfully updated.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/AutoCertificateRead"}}}},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/NotAllowed"},"404":{"$ref":"#/components/responses/NotFound"},"409":{"$ref":"#/components/responses/Conflict"},"415":{"$ref":"#/components/responses/UnsupportedMediaType"},"422":{"$ref":"#/components/responses/UnprocessableEntity"},"429":{"$ref":"#/components/responses/TooManyRequests"},"500":{"$ref":"#/components/responses/InternalError"},"503":{"$ref":"#/components/responses/ServiceUnavailable"},"default":{"$ref":"#/components/responses/UnexpectedError"}}}}}}
```
